#include <Servo.h>

Servo myservo;

int servopin = 9;
int AIN1 = 12;
int AIN2 = 13;
int PWMA = 11;

int baselineTemp = 20;  // Set baseline temperature in Celsius
float celsius = 0; //use of float due to non integer value returned
float fahrenheit = 0;

void setup() {
  pinMode(A0, INPUT);  
  myservo.attach(servopin);
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(PWMA, OUTPUT);

  Serial.begin(9600);  
}

void loop() {
  // Read the temperature sensor and convert it to Celsius
  float sensorValue = analogRead(A0);
  celsius = ((sensorValue * .00488758553)-0.5) * 100;  // Convert to Celsius

  fahrenheit = (celsius * 9) / 5 + 32;  // Convert to Fahrenheit
  Serial.print(celsius);
  Serial.print(" C, ");
  Serial.print(fahrenheit);
  Serial.println(" F");

  
  if (celsius <= baselineTemp) {
    // Turn off fan when temperature is below or equal to baseline
    myservo.write(0);  // Servo at 0 degrees
    digitalWrite(AIN1, LOW);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 0);  // Turn off motor
  }
  else if (celsius > baselineTemp && celsius <= (baselineTemp + 5)) {
    // Low speed
    myservo.write(20);
    delay(1000);
    myservo.write(120);
    delay(1000);
    myservo.write(20);

    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 40);  // Motor speed at 80
  }
  else if (celsius > (baselineTemp + 5) && celsius <= (baselineTemp + 15)) {
    // Medium speed
    myservo.write(20);
    delay(1000);
    myservo.write(120);
    delay(1000);
    myservo.write(20);

    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 100);  // Motor speed at 100
  }
  else if (celsius > (baselineTemp + 15) && (celsius <= (baselineTemp + 20))) {
    // High speed
    myservo.write(20);
    delay(1000);
    myservo.write(120);
    delay(1000);
    myservo.write(20);

    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 180);  // Motor speed at 180
  }
  else if ( celsius > (baselineTemp + 20) && (celsius <= (baselineTemp + 23.3))) {
    // Max speed
    myservo.write(20);
    delay(1000);
    myservo.write(120);
    delay(1000);
    myservo.write(20);

    digitalWrite(AIN1, HIGH);
    digitalWrite(AIN2, LOW);
    analogWrite(PWMA, 225);  // Motor speed at 225
  }

  delay(1000);  // Delay 1 second
}

  
  
  
  


